/************************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery and
Retrieval, 1994. 

Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby granted
without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact. 

2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of noteworthy
uses of this software. 

3. The names of MCNC and Clearinghouse for Networked Information Discovery
and Retrieval may not be used in any advertising or publicity relating to
the software without the specific, prior written permission of MCNC/CNIDR. 

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
************************************************************************/

/*@@@
File:		result.cxx
Version:	1.00
Description:	Class RESULT - Search Result
Author:		Nassib Nassar, nrn@cnidr.org
@@@*/

#include "result.hxx"

RESULT::RESULT() {
}

RESULT& RESULT::operator=(const RESULT& OtherResult) {
	Key = OtherResult.Key;
	PathName = OtherResult.PathName;
	FileName = OtherResult.FileName;
	RecordStart = OtherResult.RecordStart;
	RecordEnd = OtherResult.RecordEnd;
	Score = OtherResult.Score;
	return *this;
}

void RESULT::SetKey(const STRING& NewKey) {
	Key = NewKey;
}

void RESULT::GetKey(PSTRING StringBuffer) {
	*StringBuffer = Key;
}

void RESULT::SetPathName(const STRING& NewPathName) {
	PathName = NewPathName;
}

void RESULT::GetPathName(PSTRING StringBuffer) {
	*StringBuffer = PathName;
}

void RESULT::SetFileName(const STRING& NewFileName) {
	FileName = NewFileName;
}

void RESULT::GetFileName(PSTRING StringBuffer) {
	*StringBuffer = FileName;
}
void RESULT::GetFullFileName(PSTRING StringBuffer) {
	*StringBuffer = PathName;
	StringBuffer->Cat(FileName);
}

void RESULT::SetRecordStart(const GPTYPE NewRecordStart) {
	RecordStart = NewRecordStart;
}

GPTYPE RESULT::GetRecordStart() {
	return RecordStart;
}

void RESULT::SetRecordEnd(const GPTYPE NewRecordEnd) {
	RecordEnd = NewRecordEnd;
}

GPTYPE RESULT::GetRecordEnd() {
	return RecordEnd;
}

void RESULT::SetScore(const DOUBLE NewScore) {
	Score = NewScore;
}

DOUBLE RESULT::GetScore() const {
	return Score;
}

LONG RESULT::GetRecordSize() {
	return (RecordEnd - RecordStart + 1);
}

LONG RESULT::GetRecordData(PCHR Buffer, LONG BufferSize) {
	LONG RecSize = GetRecordSize();
	LONG ReadSize;
	if (BufferSize < RecSize)
		ReadSize = BufferSize;
	else
		ReadSize = RecSize;
	STRING Fn;
	PFILE Fp;
	LONG ActualSize;
	GetFullFileName(&Fn);
	Fp = fopen(Fn, "r");
	fseek(Fp, RecordStart, 0);
	ActualSize = fread(Buffer, 1, RecSize, Fp);
	fclose(Fp);
	return ActualSize;
}

RESULT::~RESULT() {
}


