#define USE_STDARGS

#include "platform.h"
#include "imem.h"
#include <string.h>
#include <stdio.h>
#ifdef USE_STDARGS
#include <stdarg.h>
#else
#include <vararg.h>
#endif
#include "logbox.h"
 
void
#ifdef USE_STDARGS
logbox_Log(FILE *pLogFile, long pLevel1, long pLevel2, char *pFormat, ...)
#else
logbox_Log(va_alist) va_dcl
#endif
{
        va_list ap;
 
#ifndef USE_STDARGS
        long lLevel1, lLevel2;
        char *lFormat;
        FILE *lLogFile;
 
        va_start(ap);
        lLogFile   = va_arg(ap, FILE *);
        lLevel1 = va_arg(ap, long);
        lLevel2 = va_arg(ap, long);
        lFormat = va_arg(ap, char *);
 
        if(lLogFile!=NULL) {
                /* Write to log file */
                vfprintf(lLogFile,lFormat, ap);
                fprintf(lLogFile,"\n");
                fflush(lLogFile);
        }
 
        va_end(ap);
#else
        va_start(ap, pFormat);
 
 
 
        if(pLogFile!=NULL) {
        /* Write to log file */
                vfprintf(pLogFile,pFormat, ap);
                fprintf(pLogFile,"\n");
                fflush(pLogFile);
        }
 
        va_end(ap);
#endif /* ifndef USE_STDARGS */
 
}
 

