#!/bin/sh
#
# Creates gdt-sys.h
#
echo ""
echo "Configuring data types header file."
echo "Ignore any errors in this next part..."
rm -f  gdt-cnf1  gdt-cnf1.c
sed 's/^X//' << 'SHAR_EOF' > gdt-cnf1.c &&
X/*@@@
XFile:		gdt-cnf1.c
XVersion:	0.00.01
XDescription:	GDT Configuration Program, pass 1
XAuthor:		Nassib Nassar, nrn@cnidr.org
X@@@*/
X
X#include <stdio.h>
X
Xvoid main() {
X
X	int x;
X
X	x = 0;
X
X#ifdef CSHORT
X	x = sizeof(short int);
X#endif
X
X#ifdef CINT
X	x = sizeof(int);
X#endif
X
X#ifdef CLONG
X	x = sizeof(long int);
X#endif
X
X#ifdef CLONGLONG
X	x = sizeof(long long int);
X#endif
X
X	printf("%d\n", x);
X}
SHAR_EOF
chmod 0644 gdt-cnf1.c || echo "Error creating gdt-cnf1.c"
$1  -DCSHORT  -o gdt-cnf1  gdt-cnf1.c
./gdt-cnf1  > gdt-cnf1.tmp
$1  -DCINT  -o gdt-cnf1  gdt-cnf1.c
./gdt-cnf1  >> gdt-cnf1.tmp
$1  -DCLONG  -o gdt-cnf1  gdt-cnf1.c
./gdt-cnf1  >> gdt-cnf1.tmp
$1  -DCLONGLONG  -o gdt-cnf1  gdt-cnf1.c
./gdt-cnf1  >> gdt-cnf1.tmp
echo ""
echo "From here on you shouldn't see any errors."
echo "If you do, then something went wrong..."
echo "------------------------------------------------------"
rm -f  gdt-cnf2  gdt-cnf2.c
sed 's/^X//' << 'SHAR_EOF' > gdt-cnf2.c &&
X/*@@@
XFile:		gdt-cnf2.c
XVersion:	0.00.01
XDescription:	GDT Configuration Program, pass 2
XAuthor:		Nassib Nassar, nrn@cnidr.org
X@@@*/
X
X#include <stdio.h>
X#include <stdlib.h>
X#include <string.h>
X
Xvoid main() {
X	char s[256];
X	int siz[4][2];
X	char names[4][80];
X	int x, z;
X	int found;
X	for (x=0; x<4; x++) {
X		gets(s);
X		siz[x][0] = atoi(s);
X		siz[x][1] = 0;
X	}
X	strcpy(names[0], "short int");
X	strcpy(names[1], "int");
X	strcpy(names[2], "long int");
X	strcpy(names[3], "long long int");
X	printf("/*@@@\n");
X	printf("File:\t\tgdt-sys.h\n");
X	printf("Version:\t(system-specific configuration)\n");
X	printf("Description:\tSystem-specific data type definitions\n");
X	printf("Author:\t\tNassib Nassar, nrn@cnidr.org\n");
X	printf("@@@*/\n\n");
X	printf("#ifndef GDT_SYS_H\n");
X	printf("#define GDT_SYS_H\n\n");
X	printf("/* System-specific typedefs */\n");
X	for (z=2; z<=8; z+=2) {
X		found = -1;
X		for (x=0; ((x<4) && (found==-1)); x++) {
X			if ( (siz[x][0] == z) && (siz[x][1] == 0) )
X				found = x;
X		}
X		if (found != -1) {
X			siz[found][1] = 1;
X			printf("typedef %s INT%d;\n", names[found], z);
X			printf("typedef INT%d* PINT%d;\n", z, z);
X			printf("typedef unsigned %s UINT%d;\n", names[found], z);
X			printf("typedef UINT%d* PUINT%d;\n", z, z);
X		}
X	}
X	printf("\n#endif /* GDT_SYS_H */\n\n");
X}
SHAR_EOF
chmod 0644 gdt-cnf2.c || echo "Error creating gdt-cnf2.c"
$1  -o gdt-cnf2  gdt-cnf2.c
./gdt-cnf2  < gdt-cnf1.tmp  > gdt-sys.h
rm -f  gdt-cnf1  gdt-cnf1.tmp  gdt-cnf1  gdt-cnf2  gdt-cnf1.c  gdt-cnf2.c
echo "------------------------------------------------------"
echo "Header file gdt-sys.h has been created."
echo "That's it, all done--unless there were errors in"
echo "this last part (between the two lines above)."
