/************************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery and
Retrieval, 1994. 

Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby granted
without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact. 

2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of noteworthy
uses of this software. 

3. The names of MCNC and Clearinghouse for Networked Information Discovery
and Retrieval may not be used in any advertising or publicity relating to
the software without the specific, prior written permission of MCNC/CNIDR. 

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
************************************************************************/

/*@@@
File:           session.h
Version:        1.02
Author:         Kevin Gamiel, kgamiel@cnidr.org
@@@*/

#ifndef _session_
#define _session_

#include "gdt.h"

#define MAXSESSIONSTRING 1024
#define MAXNETBUFFERSIZE 50000
#define MAXNUMRECS 500
#define TEMPGROUP "Temp"

/*, huge, enormous Session table */
struct _session {
	CHR ServerType[MAXSESSIONSTRING];
        INT MaxSessions;
	CHR Host[MAXSESSIONSTRING];
        INT Port;
        INT4 TimeOut;
	CHR OutputFile[MAXSESSIONSTRING];
	CHR StatsFile[MAXSESSIONSTRING];
	CHR Trace[MAXSESSIONSTRING];
	CHR TraceLog[MAXSESSIONSTRING];
	CHR Stats[MAXSESSIONSTRING];
	CHR StatsLog[MAXSESSIONSTRING];
	FILE *TFP;
	CHR AccessLog[MAXSESSIONSTRING];
	CHR SAPI[MAXSESSIONSTRING];
	CHR ServerPath[MAXSESSIONSTRING];
	CHR QueryFormat[MAXSESSIONSTRING];
	CHR DisplayRecSyntax[MAXSESSIONSTRING];
	CHR DBList[MAXSESSIONSTRING];
	CHR DBPath[MAXSESSIONSTRING];
	CHR DiagSetId[MAXSESSIONSTRING];
	CHR iAuthentication[MAXSESSIONSTRING];
	CHR iImpID[MAXSESSIONSTRING];
	CHR iImpName[MAXSESSIONSTRING];
	CHR iImpVersion[MAXSESSIONSTRING];
	INT4 iProtocolVersion;
	CHR iOptions[MAXSESSIONSTRING];
        INT4 iPreferredMsgSize;
        INT4 iMaxRecSize;
	CHR iUserInformationField[MAXSESSIONSTRING];
	CHR iReferenceId[MAXSESSIONSTRING];
	INT4 iResult;
	CHR sReferenceId[MAXSESSIONSTRING];
	INT4 sResultCount;
        INT4 sSmallSetUpperBound;
        INT4 sLargeSetLowerBound;
        INT4 sMedSetPresentNum;
	unsigned char sReplaceIndicator;
	CHR sResultSetName[MAXSESSIONSTRING];
	CHR sDBNames[MAXSESSIONSTRING];
	CHR sSmallSetElementSetNames[MAXSESSIONSTRING];
	CHR sMediumSetElementSetNames[MAXSESSIONSTRING];
	CHR sPreferredRecordSyntax[MAXSESSIONSTRING];
	CHR sQuery[MAXSESSIONSTRING];
	CHR sAttributeSet[MAXSESSIONSTRING];
	CHR pReferenceId[MAXSESSIONSTRING];
	CHR pResultSetId[MAXSESSIONSTRING];
        INT4 pResultSetStartPoint;
        INT4 pNumRecsReq;
	CHR pElementSetNames[MAXSESSIONSTRING];
	CHR pPreferredRecSyntax[MAXSESSIONSTRING];
        INT4 pNumRecsReturned;
        INT4 pNextResultSetPos;
};
 
typedef struct _session SESSION;
typedef struct _session *PSESSION;

#ifdef INI_USE
INT4 GetPrivateProfileLong(PCHR pszSection, PCHR pszEntry, INT4
	pszDefault, PCHR pszFileName);

#endif
INT GetCmdLineSettings(SESSION* S, INT ac, PCHR* argv, PCHR profilefn,
		CHR* profilegroup);
INT ReadProfileSettings(SESSION *S, PCHR File, PCHR Group);

#endif /* _session_ */

