/************************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery and
Retrieval, 1994. 

Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby granted
without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact. 

2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of noteworthy
uses of this software. 

3. The names of MCNC and Clearinghouse for Networked Information Discovery
and Retrieval may not be used in any advertising or publicity relating to
the software without the specific, prior written permission of MCNC/CNIDR. 

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
************************************************************************/

/*@@@
File:           zstats.h
Version:        1.02
Author:         Kevin Gamiel, kgamiel@cnidr.org
@@@*/

#ifndef _zstats_
#define _zstats_

/* header for stats file ? */
#include "gdt.h"
#include <time.h>

typedef struct tagZSTATS {
	INT4 BytesSent;
	INT4 BytesRec;
	CHR Host[80];
	time_t Time;
	INT4 SessionLength;
	INT4 InitRequestCount;
	INT4 InitResponseCount;
	INT4 SearchRequestCount;
	INT4 SearchResponseCount;
	INT4 PresentRequestCount;
	INT4 PresentResponseCount;
	INT4 DeleteResultSetRequestCount;
	INT4 DeleteResultSetResponseCount;
	INT4 AccessControlRequestCount;
	INT4 AccessControlResponseCount;
	INT4 ResourceControlRequestCount;
	INT4 ResourceControlResponseCount;
	INT4 TriggerResourceControlCount;
	INT4 ResourceReportRequestCount;
	INT4 ResourceReportResponseCount;
	INT4 ScanRequestCount;
	INT4 ScanResponseCount;
	INT4 SortRequestCount;
	INT4 SortResponseCount;
	INT4 SegmentRequest;
	INT4 ExtendedServicesRequestCount;
	INT4 ExtendedServicesResponseCount;
	INT4 CloseRequestCount;
} ZSTATS;

typedef ZSTATS *PZSTATS;

PZSTATS zstats_Create();
PZSTATS zstats_CreateInit(PCHR Host);
void zstats_SetHost(PZSTATS s, PCHR Host);
void zstats_SetDateTime(PZSTATS s);
void zstats_AddPDU(PZSTATS s, DATA_DIR *d);
void zstats_Display(PZSTATS s, FILE *fp);
void zstats_WriteLog(PZSTATS s, PCHR f);
PLIST zstats_ReadLog(PCHR f);
void zstats_Accumulate(PZSTATS dest, PZSTATS src);

#endif
