/************************************************************************
Copyright Notice

Copyright (c) MCNC, Clearinghouse for Networked Information Discovery and
Retrieval, 1994. 

Permission to use, copy, modify, distribute, and sell this software and
its documentation, in whole or in part, for any purpose is hereby granted
without fee, provided that

1. The above copyright notice and this permission notice appear in all
copies of the software and related documentation. Notices of copyright
and/or attribution which appear at the beginning of any file included in
this distribution must remain intact. 

2. Users of this software agree to make their best efforts (a) to return
to MCNC any improvements or extensions that they make, so that these may
be included in future releases; and (b) to inform MCNC/CNIDR of noteworthy
uses of this software. 

3. The names of MCNC and Clearinghouse for Networked Information Discovery
and Retrieval may not be used in any advertising or publicity relating to
the software without the specific, prior written permission of MCNC/CNIDR. 

THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND,
EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY WARRANTY
OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. 

IN NO EVENT SHALL MCNC/CNIDR BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF THE
POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT OF OR
IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE. 
************************************************************************/

/*@@@
File:           zutil.h
Version:        1.02
Author:         Kevin Gamiel, kgamiel@cnidr.org
@@@*/

#ifndef _zutil_
#define _zutil_

#include "gdt.h"
#include "cutil.h"
#include "netbox.h"
#include "z3950.h"

INT4 zutil_GetBERFromNet(NETBOXPROFILE *profile, PUCHR b, INT4 maxbuffersize);
void zutil_Log(DATA_DIR * O, PCHR FileName);
void zutil_LogToStream(DATA_DIR * O, FILE *S);
INT4 zutil_GetTaggedInt(DATA_DIR * D, INT4 Tag);
unsigned char zutil_GetTaggedUnsignedChar(DATA_DIR * D, INT4 Tag);
PUCHR zutil_GetTaggedOctetString(DATA_DIR * D, INT4 Tag, PUCHR Buf, INT4 Size);
DATA_DIR *zutil_GetTaggedObject(DATA_DIR *D, INT4 Tag);
INT4 zutil_GetTag(DATA_DIR * D);
PUCHR far zutil_GetBEREncodedBuffer(DATA_DIR * D, PUCHR Buffer, PINT4 Length,
	INT4 MaxRecordSize);
DATA_DIR * far zutil_CreateFromData(PUCHR Buffer, INT4 Length);
void zutil_LogPDU(DATA_DIR *d, FILE *fp);
void zutil_AddToFile(PCHR File, PCHR s);
void zutil_StripAttributes(PCHR S);
INT zutil_GetArgs(PCHR S, PCHR Arg1, PCHR Arg2);
INT zutil_IsBooleanOp(PCHR S);
 
#endif /* _zutil_ */

